include <../../../openscad/meca.scad>
include <../../../openscad/math.scad>
use <../../../openscad/Nema17.scad>
include <../../../openscad/module_laser.scad>
use <../../../openscad/fixations.scad>

/**************************************************************
************************PIÈCES ACHETÉES************************
**************************************************************/
courroie_larg = 10;

/**************************************************************
***************************CHARIOT X***************************
**************************************************************/
chariot_X_ecart_LM8LUU = 40;
chariot_X_epaisseur = 3;
chariot_X_marge = [4, 2, 6];

chariot_X = [	LM8LUU_long + chariot_X_marge[0],
				LM8LUU_diam_ext/2 + chariot_X_marge[1],
				chariot_X_ecart_LM8LUU + LM8LUU_diam_ext + chariot_X_marge[2]];

chariot_Y_ecart_poulie = poulie_lisse_GT2_20_dents_diam_ext + 1;

chariot_X_ecart_delta_courroie1 = -chariot_Y_ecart_poulie/2 + poulie_crantee_GT2_20_dents_diam_int/2;
chariot_X_ecart_delta_courroie2 = chariot_Y_ecart_poulie/2 - poulie_lisse_GT2_20_dents_diam_int/2 - courroie_GT2_epais_bande;

courroie_ecart = chariot_X_ecart_delta_courroie2 - chariot_X_ecart_delta_courroie1;

chariot_Y_marge = [4, 6, 6];
chariot_Y_ecart_LM8LUU = chariot_X_ecart_LM8LUU + LM8LUU_diam_ext + 8 + 2;

chariot_Y = [	LM8LUU_diam_ext/2 + chariot_Y_marge[0],
				LM8LUU_long + chariot_Y_marge[1],
				chariot_Y_ecart_LM8LUU + LM8LUU_diam_ext + chariot_Y_marge[2]
			];
			
chariot_Y_surplus_fin_de_course = 4;

/**************************************************************
***************************FIXATION****************************
**************************************************************/
fixation_d1 = 19.6;
fixation_d2 = 30.3;
fixation_diam = (fixation_d2 - fixation_d1)/2;
fixation_ecart_z = fixation_d1 + fixation_diam;
fixation_delta_y = 5.2;
fixation_epaisseur = 1.9;
fixation_long = 71;
fixation_hauteur = 6*fixation_ecart_z;
milieu_Z = fixation_hauteur/2;

/**************************************************************
****************************MOTEUR*****************************
**************************************************************/

/*le décallage des guides par rapport à l'axe du moteur :
Ce décalage prend en compte la poulie moteur
l'épaisseur de la courroie
et la poulie du chariot Y
*/
Moteur_axes_Y_delta_X = poulie_crantee_GT2_12_dents_diam_int/2 + courroie_GT2_epais_bande + poulie_crantee_GT2_20_dents_diam_int/2;

/*pour que la partie moteur ne dépasse pas le chariot Y il faut que :
X = 22.5 + Moteur_axes_Y_delta_X + chariot_Y[0]
Sur l'axe Y, la partie moteur sera simplement la longueur de la fixation
Y = fixation_long
Sur l'axe Z cela dépend de la distance entre les guides :
marge = 20;
Z = chariot_Y_ecart_LM8LUU + marge_Z
*/
Moteur_marge_Z = 20;
Moteur_position = [Nema_17_largeur/2 - 22.5 + 1, 0, milieu_Z];
Moteur_taille = [22.5 + Moteur_axes_Y_delta_X + chariot_Y[0] + Moteur_position[0], fixation_long, chariot_Y_ecart_LM8LUU + Moteur_marge_Z];
Moteur_fixation_long = 5;

/*************************************************************
************************FIN DE COURSE*************************
**************************************************************/

fin_de_course_taille = [40 + 5, 16.5];
fin_de_course_haut = 10;
fin_de_course_entraxe_1 = 15.4;
fin_de_course_entraxe_2 = 22.7;
fin_de_course_diam = 3.5;

/**************************************************************
*************************BLOC POULIES**************************
**************************************************************/
bloc_poulies_taille = [22.5 - 8 + Moteur_axes_Y_delta_X + chariot_Y[0] + Moteur_position[0] - 4, fixation_long, chariot_Y_ecart_LM8LUU + Moteur_marge_Z];